\documentclass[12pt,txfonts]{paper}

\setlength\parindent{0pt}
\setlength\parskip{6pt}

\begin{document}

\section*{Generating S-function formulae using Mathematica}

The first step is to generate the S functions $\overline S_{l_1l_2j}^{00}$.
The RRF program Sfns is a Fortran executable program that
calculates the product of two S functions as a linear combination of
single S functions. Run the program (just type `Sfns' on the command
line) for instructions. For electrostatic interactions use only
$S(l_1,l_2,j,m_1,m_2)$ with $l_1+l_2=j$ and $m_1=m_2=0$.
An example of the output is:
\begin{verbatim}
S(2,2,4;0,0)*S(1,0,1;0,0) =
        S(1,2,3;0,0) * 2/5
     +  S(3,2,3;0,0) * -2/45
     +  S(3,2,5;0,0) * 5/9
\end{verbatim}

This can be rearranged to express $\overline S_{325}^{00}$ in terms of
S functions of lower total rank:
\begin{equation*}
\overline S_{325}^{00} = (9/5)*\Bigl(\overline S_{224}^{00}\overline S_{101}^{00}
+(2/45)*\overline S_{323}^{00} - (2/5)*\overline S_{123}^{00}\Bigr).
  \end{equation*}
The Mathematica notebook \texttt{S00functions.nb} contains definitions
of many S functions in terms of the direction cosines, including all
those on the RHS of the 
equation above, so this formula can be used to obtain an expression
for $\overline S_{325}^{00}$ in terms of the direction cosines. In
fact it is already included as the penultimate expression in the notebook.

In this way it is straightforward to obtain expressions for any
$\overline S_{l_1 l_2 j}^{00}$ that may be needed. It's a bit tedious
but it only has to be done once for each $l_1 l_2 j$.

To obtain the $\overline S_{l_1 l_2 j}^{k_1 k_2}$ is a bit more
laborious, but again only has to be done once. The procedure leads to
Fortran formulae for the S functions and all their nonzero
derivatives.

Start with the notebook Sfns.nb. This generates the formulae for the S
functions $\overline S_{l_1 l_2 j}^{k_1 k_2}$ in real form from the formula for
$\overline S_{l_1 l_2 j}^{00}$, using recursion formulae.

The first part of this notebook doesn't need to be changed. Find the
line ``New input starts here'', and change the values for $l_1$, $l_2$ and $j$
just below. Then a few lines further on, enter the formula for
$\overline S_{l_1 l_2 j}^{00}$ in terms of the direction cosines, as
obtained in Sfns.nb. The procedure can 
be used for either the plain $S$ or the $\overline S$ functions,
though the latter are usually used.

Now evaluate the notebook (Evaluation $\to$ Evaluate notebook). The
formulae for $\overline S_{l_1 l_2 j}^{k_1 k_2}$ should appear at the end of the
notebook, as $Sl_1l_2j[k_1,k_2]$, where $k_1 = 0$, 1, ..., $2l_1$ correspond to
the $0$, $1c$, $1s$, ..., $l_1s$ components,

Now paste the above output into a new notebook, and save it in text
format. Edit the result, as a text file,  so that each formula is
preceded by \verb:"\!\(": and terminated by \verb:"\)":, and edit out every
\verb:"[x,y,u,v]":. Precede the result by e.g.
\verb:"\!\(Array[S134,{3,7},{0,0}]\)": (in general,
\verb:\!\(Array[S:$l_1l_2j$\verb:,{:$2l_1+1,2l_2+1$\verb:},{0,0}]\)":.
All of this can be done by the command\\ 
\verb+./convert.py S314.txt+\\

Paste this edited file into a new empty notebook, or into the
beginning of the notebook\break \verb:Sfn_deriv.nb:, first deleting the entire
first cell from the previous set of S functions, down to ``end of
pasted-in material''. Specify the angular momentum values $l_1$, $l_2$
and $j$, and set alabel, blabel and jlabel to the appropriate sets of labels.
Change the S-function name (in 3 places), and set the values of $t$
and $n$, which are respectively the ordinal number of the S function
in the complete list, and the ordinal number in the sub-list for the
value of $l_1+l_2-j$. The values should be the values for the S
function immediately preceding the first of the new ones.

Executing this notebook should then produce a file Sl$_1$l$_2$j.f90
containing the Fortran definitions for the function and its non-zero
derivatives. Finally apply the cleanup.py script to this generated f90
file. 

The current version of the \verb:Sfn_deriv134ss.nb: notebook also
generates a file \verb:S134ss.f90: that evaluates the S functions and
derivatives for the site--site axis system. In this case all the
functions and derivatives reduce to numerical values.
\end{document}
